/*
 * Ported from: NGramLMTypes.h (Original Author: Keith Vertanen)
 */

import java.util.Comparator;

/**
 * Functor that we use to sort our vector of bigram pointers, sort by unique ID
 */
public class CompNGramLM implements Comparator<NGramLMBase> {

	@Override
	public int compare(NGramLMBase pObj1, NGramLMBase pObj2) {
		if (pObj1.GetSize() != pObj2.GetSize())
			return 1;
		int ID1;
		int ID2;
		for (int i = 0; i < pObj1.GetSize(); ++i)
		{
			ID1 = pObj1.GetID(i);
			ID2 = pObj2.GetID(i);
			if (ID1 < ID2)
				return -1;
			else if (ID1 > ID2)
				return 1;
		}
		return 1;
	}
	
}
