/*
 * Ported from: NGramLMTypes.h (Original Author: Keith Vertanen)
 */

import java.io.PrintStream;
import java.util.Iterator;
import java.util.List;

public class NGram1 extends NGramLMBase {
	
	public int[]					m_pWords = new int[1];

	public NGram1(float fLogProb, float fLogBackoff, int iID1)						
	{ 
		m_fLogProb		= fLogProb;
		m_fLogBackoff	= fLogBackoff;
		m_pWords[0]		= iID1; 
	}
	
	public NGram1(float fLogProb, float fLogBackoff, List<Integer> vecIDs)
	{ 
		m_fLogProb		= fLogProb;
		m_fLogBackoff	= fLogBackoff;
		int i = 0;
		Iterator<Integer> iter = vecIDs.iterator();
		while (iter.hasNext()) {
			if (vecIDs.size() == 1)
				m_pWords[i] = iter.next().intValue();
			else
				m_pWords[i]	= NGramLMTypes.NGRAM_WORD_ID_MAX;
			++i;
		}
	}
	
	public String GetWords(List<String> pWords)
	{
		String strResult = "";
		if (pWords != null)
		{
			strResult += pWords.get(m_pWords[0]);
		}
		return strResult;
	}
	
	public void Write(PrintStream fp, int iTrunc, boolean bWriteBackoff, List<String> pWords)
	{
		if (fp != null)
		{
			WriteTruncFloat(fp, m_fLogProb / NGramLMTypes.LN_10, iTrunc);
			fp.printf("\t%s", pWords.get(m_pWords[0]));
			if (bWriteBackoff)
			{
				fp.printf("\t");
				WriteTruncFloat(fp, m_fLogBackoff / NGramLMTypes.LN_10, iTrunc);
			}
			fp.printf("\n");
		}
	}

	public int	GetSize()			
	{ 
		return 1; 
	}
	
	public int	GetLastID()
	{
		return m_pWords[0];
	}
	
	public int	GetFirstID()
	{
		return m_pWords[0];
	}
	
	public int	GetID(int iPos)
	{
		if (iPos < 1)
			return m_pWords[iPos];
		return NGramLMTypes.NGRAM_WORD_ID_MAX;
	}

}
