
import java.io.PrintStream;
import java.util.List;

/**
 * For storing 7-grams and larger
 */
public class NGram7Plus extends NGramLMBase {
	
	public int[]		m_ppWords;
	public byte			m_iSize;

	public NGram7Plus(float fLogProb, float fLogBackoff, List<Integer> vecIDs)
	{ 
		m_fLogProb		= fLogProb;
		m_fLogBackoff	= fLogBackoff;
		m_ppWords		= null;
		m_iSize			= 0;
		if (vecIDs.size() > 0)
		{
			m_iSize = (byte) vecIDs.size();
			m_ppWords = new int[m_iSize];
			for (int i = 0; i < m_iSize; ++i)
				m_ppWords[i] = vecIDs.get(i);
		}
	}

	public String GetWords(List<String> pWords)
	{
		String strResult = "";
		if (pWords != null)
		{
			for (int i = 0; i < m_iSize; ++i)
			{
				if (i > 0)
					strResult += " ";
				strResult += pWords.get(m_ppWords[i]);
			}
		}
		return strResult;
	}

	public void Write(PrintStream fp, int iTrunc, boolean bWriteBackoff, List<String> pWords)
	{
		if (fp != null)
		{
			WriteTruncFloat(fp, m_fLogProb / NGramLMTypes.LN_10, iTrunc);						
			fp.printf("\t");
			for (int i = 0; i < m_iSize; ++i)
			{
				if (i > 0)
					fp.printf(" %s", pWords.get(m_ppWords[i]));
				else
					fp.printf("%s", pWords.get(m_ppWords[i]));
			}
			if (bWriteBackoff)
			{
				fp.printf("\t");
				WriteTruncFloat(fp, m_fLogBackoff / NGramLMTypes.LN_10, iTrunc);
			}
			fp.printf("\n");
		}
	}	

	public int	GetSize()			
	{ 
		return m_iSize; 
	}
	
	public int	GetFirstID()
	{
		if (m_iSize == 0)
			return NGramLMTypes.NGRAM_WORD_ID_MAX;
		return m_ppWords[0];
	}
	public int GetLastID()
	{
		if (m_iSize == 0)
			return NGramLMTypes.NGRAM_WORD_ID_MAX;
		return m_ppWords[m_iSize - 1];
	}
	
	public int GetID(int iPos)
	{
		if (iPos < m_iSize)
			return m_ppWords[iPos];
		return NGramLMTypes.NGRAM_WORD_ID_MAX;
	}

}
